/*
 * Copyright 2016 - 2025 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <ox/std/memory.hpp>

#include <turbine/context.hpp>

#include "initparams.hpp"

namespace nostalgia::gfx {

class Context;

void safeDelete(Context *ctx) noexcept;

ox::Result<ox::UPtr<Context>> init(turbine::Context &tctx, InitParams const&params = {}) noexcept;

keel::Context &keelCtx(Context &ctx) noexcept;

turbine::Context &turbineCtx(Context &ctx) noexcept;

}

