/*
 * Copyright 2016 - 2025 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include <ox/std/size.hpp>
#include <ox/std/stringview.hpp>

#include <teagba/addresses.hpp>
#include <teagba/gfx.hpp>
#include <teagba/irq.hpp>

#include <turbine/context.hpp>

namespace turbine {

ox::Error initGfx(Context&) noexcept {
	REG_DISPCTL = teagba::DispCtl_Mode0
	            | teagba::DispCtl_SpriteMap1D
	            | teagba::DispCtl_Obj;
	// tell display to trigger vblank interrupts
	REG_DISPSTAT = REG_DISPSTAT | teagba::DispStat_irq_vblank;
	// enable vblank interrupt
	REG_IE = REG_IE | teagba::Int_vblank;
	return {};
}

void setWindowTitle(Context&, ox::StringViewCR) noexcept {
}

int getScreenWidth(Context const&) noexcept {
	return 240;
}

int getScreenHeight(Context const&) noexcept {
	return 160;
}

ox::Size getScreenSize(Context const&) noexcept {
	return {240, 160};
}

ox::Bounds getWindowBounds(Context const&) noexcept {
	return {0, 0, 240, 160};
}

ox::Error setWindowBounds(Context&, ox::Bounds const&) noexcept {
	return ox::Error(1, "setWindowBounds not supported on GBA");
}

}
